package main

import (
	"fmt"
	"log"
	"os"
	"sync"

	kyoketsu "git.aetherial.dev/aeth/kyoketsu/pkg"
)

func main() {
	//	kyoketsu.PingWithDependency(os.Args[1])
	//	os.Exit(1)

	if len(os.Args) == 1 {
		log.Fatal("Please pass in the name of an interface that belongs to the network to scan.")
	}
	addr, err := kyoketsu.GetAllAddresses(os.Args[1])
	if err != nil {
		log.Fatal(err)
	}
	var wg sync.WaitGroup
	for i := range addr.Addr {
		wg.Add(1)
		go func(idx int, wg *sync.WaitGroup) {

			out := kyoketsu.PortWalk(addr.Addr[idx].String(), kyoketsu.PORT_MAP)
			if len(out.ListeningPorts) > 0 {
				fmt.Printf("%+v\n", out)

			}

			wg.Done()
		}(i, &wg)
	}

	wg.Wait()

}
